diff -urN sbcl-0.8.16/src/runtime/gc-common.c sbcl-0.8.16.patched/src/runtime/gc-common.c
--- sbcl-0.8.16/src/runtime/gc-common.c	2004-09-14 19:25:17.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/gc-common.c	2004-10-26 17:08:22.000000000 +0200
@@ -779,6 +779,56 @@
 }
 
 static int
+size_character_string(lispobj *where)
+{
+    struct vector *vector;
+    int length, nwords;
+
+    /* NOTE: A string contains one more byte of data (a terminating
+     * '\0' to help when interfacing with C functions) than indicated
+     * by the length slot. */
+
+    vector = (struct vector *) where;
+    length = fixnum_value(vector->length) + 1;
+    nwords = CEILING(NWORDS(length, 32) + 2, 2);
+
+    return nwords;
+}
+
+scav_character_string(lispobj *where, lispobj object)
+{
+    struct vector *vector;
+    int length, nwords;
+
+    /* NOTE: Strings contain one more byte of data than the length */
+    /* slot indicates. */
+
+    vector = (struct vector *) where;
+    length = fixnum_value(vector->length) + 1;
+    nwords = CEILING(NWORDS(length, 32) + 2, 2);
+
+    return nwords;
+}
+static lispobj
+trans_character_string(lispobj object)
+{
+    struct vector *vector;
+    int length, nwords;
+
+    gc_assert(is_lisp_pointer(object));
+
+    /* NOTE: A string contains one more byte of data (a terminating
+     * '\0' to help when interfacing with C functions) than indicated
+     * by the length slot. */
+
+    vector = (struct vector *) native_pointer(object);
+    length = fixnum_value(vector->length) + 1;
+    nwords = CEILING(NWORDS(length, 32) + 2, 2);
+
+    return copy_large_unboxed_object(object, nwords);
+}
+
+static int
 size_base_string(lispobj *where)
 {
     struct vector *vector;
@@ -1550,6 +1600,7 @@
 #endif
     scavtab[SIMPLE_ARRAY_WIDETAG] = scav_boxed;
     scavtab[SIMPLE_BASE_STRING_WIDETAG] = scav_base_string;
+    scavtab[SIMPLE_CHARACTER_STRING_WIDETAG] = scav_character_string;
     scavtab[SIMPLE_BIT_VECTOR_WIDETAG] = scav_vector_bit;
     scavtab[SIMPLE_ARRAY_NIL_WIDETAG] = scav_vector_nil;
     scavtab[SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG] =
@@ -1625,6 +1676,7 @@
 	scav_vector_complex_long_float;
 #endif
     scavtab[COMPLEX_BASE_STRING_WIDETAG] = scav_boxed;
+    scavtab[COMPLEX_CHARACTER_STRING_WIDETAG] = scav_boxed;
     scavtab[COMPLEX_VECTOR_NIL_WIDETAG] = scav_boxed;
     scavtab[COMPLEX_BIT_VECTOR_WIDETAG] = scav_boxed;
     scavtab[COMPLEX_VECTOR_WIDETAG] = scav_boxed;
@@ -1643,7 +1695,7 @@
 #endif
     scavtab[VALUE_CELL_HEADER_WIDETAG] = scav_boxed;
     scavtab[SYMBOL_HEADER_WIDETAG] = scav_boxed;
-    scavtab[BASE_CHAR_WIDETAG] = scav_immediate;
+    scavtab[CHARACTER_WIDETAG] = scav_immediate;
     scavtab[SAP_WIDETAG] = scav_unboxed;
     scavtab[UNBOUND_MARKER_WIDETAG] = scav_immediate;
     scavtab[INSTANCE_HEADER_WIDETAG] = scav_boxed;
@@ -1675,6 +1727,7 @@
 #endif
     transother[SIMPLE_ARRAY_WIDETAG] = trans_boxed; /* but not GENCGC */
     transother[SIMPLE_BASE_STRING_WIDETAG] = trans_base_string;
+    transother[SIMPLE_CHARACTER_STRING_WIDETAG] = trans_character_string;
     transother[SIMPLE_BIT_VECTOR_WIDETAG] = trans_vector_bit;
     transother[SIMPLE_VECTOR_WIDETAG] = trans_vector;
     transother[SIMPLE_ARRAY_NIL_WIDETAG] = trans_vector_nil;
@@ -1755,6 +1808,7 @@
 	trans_vector_complex_long_float;
 #endif
     transother[COMPLEX_BASE_STRING_WIDETAG] = trans_boxed;
+    transother[COMPLEX_CHARACTER_STRING_WIDETAG] = trans_boxed;
     transother[COMPLEX_BIT_VECTOR_WIDETAG] = trans_boxed;
     transother[COMPLEX_VECTOR_NIL_WIDETAG] = trans_boxed;
     transother[COMPLEX_VECTOR_WIDETAG] = trans_boxed;
@@ -1766,7 +1820,7 @@
     transother[FUNCALLABLE_INSTANCE_HEADER_WIDETAG] = trans_boxed;
     transother[VALUE_CELL_HEADER_WIDETAG] = trans_boxed;
     transother[SYMBOL_HEADER_WIDETAG] = trans_boxed;
-    transother[BASE_CHAR_WIDETAG] = trans_immediate;
+    transother[CHARACTER_WIDETAG] = trans_immediate;
     transother[SAP_WIDETAG] = trans_unboxed;
     transother[UNBOUND_MARKER_WIDETAG] = trans_immediate;
     transother[WEAK_POINTER_WIDETAG] = trans_weak_pointer;
@@ -1805,6 +1859,7 @@
 #endif
     sizetab[SIMPLE_ARRAY_WIDETAG] = size_boxed;
     sizetab[SIMPLE_BASE_STRING_WIDETAG] = size_base_string;
+    sizetab[SIMPLE_CHARACTER_STRING_WIDETAG] = size_character_string;
     sizetab[SIMPLE_BIT_VECTOR_WIDETAG] = size_vector_bit;
     sizetab[SIMPLE_VECTOR_WIDETAG] = size_vector;
     sizetab[SIMPLE_ARRAY_NIL_WIDETAG] = size_vector_nil;
@@ -1881,6 +1936,7 @@
 	size_vector_complex_long_float;
 #endif
     sizetab[COMPLEX_BASE_STRING_WIDETAG] = size_boxed;
+    sizetab[COMPLEX_CHARACTER_STRING_WIDETAG] = size_boxed;
     sizetab[COMPLEX_VECTOR_NIL_WIDETAG] = size_boxed;
     sizetab[COMPLEX_BIT_VECTOR_WIDETAG] = size_boxed;
     sizetab[COMPLEX_VECTOR_WIDETAG] = size_boxed;
@@ -1895,7 +1951,7 @@
     sizetab[FUNCALLABLE_INSTANCE_HEADER_WIDETAG] = size_boxed;
     sizetab[VALUE_CELL_HEADER_WIDETAG] = size_boxed;
     sizetab[SYMBOL_HEADER_WIDETAG] = size_boxed;
-    sizetab[BASE_CHAR_WIDETAG] = size_immediate;
+    sizetab[CHARACTER_WIDETAG] = size_immediate;
     sizetab[SAP_WIDETAG] = size_unboxed;
     sizetab[UNBOUND_MARKER_WIDETAG] = size_immediate;
     sizetab[WEAK_POINTER_WIDETAG] = size_weak_pointer;
diff -urN sbcl-0.8.16/src/runtime/gc-internal.h sbcl-0.8.16.patched/src/runtime/gc-internal.h
--- sbcl-0.8.16/src/runtime/gc-internal.h	2004-09-14 19:25:17.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/gc-internal.h	2004-10-26 17:08:22.000000000 +0200
@@ -94,7 +94,7 @@
 	/* If thing is an immediate then this is a cons. */
 	if (is_lisp_pointer(thing)
 	    || (fixnump(thing))
-	    || (widetag_of(thing) == BASE_CHAR_WIDETAG)
+	    || (widetag_of(thing) == CHARACTER_WIDETAG)
 	    || (widetag_of(thing) == UNBOUND_MARKER_WIDETAG))
 	    count = 2;
 	else
diff -urN sbcl-0.8.16/src/runtime/gencgc.c sbcl-0.8.16.patched/src/runtime/gencgc.c
--- sbcl-0.8.16/src/runtime/gencgc.c	2004-09-14 19:25:17.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/gencgc.c	2004-10-26 17:08:22.000000000 +0200
@@ -2057,11 +2057,11 @@
 	/* Is it plausible cons? */
 	if ((is_lisp_pointer(start_addr[0])
 	    || (fixnump(start_addr[0]))
-	    || (widetag_of(start_addr[0]) == BASE_CHAR_WIDETAG)
+	    || (widetag_of(start_addr[0]) == CHARACTER_WIDETAG)
 	    || (widetag_of(start_addr[0]) == UNBOUND_MARKER_WIDETAG))
 	   && (is_lisp_pointer(start_addr[1])
 	       || (fixnump(start_addr[1]))
-	       || (widetag_of(start_addr[1]) == BASE_CHAR_WIDETAG)
+	       || (widetag_of(start_addr[1]) == CHARACTER_WIDETAG)
 	       || (widetag_of(start_addr[1]) == UNBOUND_MARKER_WIDETAG)))
 	    break;
 	else {
@@ -2107,7 +2107,7 @@
 	}
 	switch (widetag_of(start_addr[0])) {
 	case UNBOUND_MARKER_WIDETAG:
-	case BASE_CHAR_WIDETAG:
+	case CHARACTER_WIDETAG:
 	    if (gencgc_verbose)
 		FSHOW((stderr,
 		       "*Wo3: %x %x %x\n",
@@ -2145,6 +2145,7 @@
 #endif
 	case SIMPLE_ARRAY_WIDETAG:
 	case COMPLEX_BASE_STRING_WIDETAG:
+	case COMPLEX_CHARACTER_STRING_WIDETAG:
 	case COMPLEX_VECTOR_NIL_WIDETAG:
 	case COMPLEX_BIT_VECTOR_WIDETAG:
 	case COMPLEX_VECTOR_WIDETAG:
@@ -2160,6 +2161,7 @@
 	case LONG_FLOAT_WIDETAG:
 #endif
 	case SIMPLE_BASE_STRING_WIDETAG:
+	case SIMPLE_CHARACTER_STRING_WIDETAG:
 	case SIMPLE_BIT_VECTOR_WIDETAG:
 	case SIMPLE_ARRAY_NIL_WIDETAG:
 	case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
@@ -2248,6 +2250,7 @@
 	break;
     case BIGNUM_WIDETAG:
     case SIMPLE_BASE_STRING_WIDETAG:
+    case SIMPLE_CHARACTER_STRING_WIDETAG:
     case SIMPLE_BIT_VECTOR_WIDETAG:
     case SIMPLE_ARRAY_NIL_WIDETAG:
     case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
@@ -3111,6 +3114,7 @@
 		case COMPLEX_WIDETAG:
 		case SIMPLE_ARRAY_WIDETAG:
 		case COMPLEX_BASE_STRING_WIDETAG:
+		case COMPLEX_CHARACTER_STRING_WIDETAG:
 		case COMPLEX_VECTOR_NIL_WIDETAG:
 		case COMPLEX_BIT_VECTOR_WIDETAG:
 		case COMPLEX_VECTOR_WIDETAG:
@@ -3119,7 +3123,7 @@
 		case FUNCALLABLE_INSTANCE_HEADER_WIDETAG:
 		case VALUE_CELL_HEADER_WIDETAG:
 		case SYMBOL_HEADER_WIDETAG:
-		case BASE_CHAR_WIDETAG:
+		case CHARACTER_WIDETAG:
 		case UNBOUND_MARKER_WIDETAG:
 		case INSTANCE_HEADER_WIDETAG:
 		case FDEFN_WIDETAG:
@@ -3197,6 +3201,7 @@
 		case COMPLEX_LONG_FLOAT_WIDETAG:
 #endif
 		case SIMPLE_BASE_STRING_WIDETAG:
+		case SIMPLE_CHARACTER_STRING_WIDETAG:
 		case SIMPLE_BIT_VECTOR_WIDETAG:
 		case SIMPLE_ARRAY_NIL_WIDETAG:
 		case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
diff -urN sbcl-0.8.16/src/runtime/interr.c sbcl-0.8.16.patched/src/runtime/interr.c
--- sbcl-0.8.16/src/runtime/interr.c	2004-08-06 17:37:35.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/interr.c	2004-10-26 17:08:22.000000000 +0200
@@ -112,7 +112,7 @@
 	    brief_print(*os_context_register_addr(context, offset));
 	    break;
 
-	case sc_BaseCharReg:
+	case sc_CharacterReg:
 	    ch = *os_context_register_addr(context, offset);
 #ifdef LISP_FEATURE_X86
 	    if (offset&1)
diff -urN sbcl-0.8.16/src/runtime/print.c sbcl-0.8.16.patched/src/runtime/print.c
--- sbcl-0.8.16/src/runtime/print.c	2004-08-10 02:20:47.000000000 +0200
+++ sbcl-0.8.16.patched/src/runtime/print.c	2004-10-26 17:08:22.000000000 +0200
@@ -218,7 +218,7 @@
 
     type = widetag_of(obj);
     switch (type) {
-        case BASE_CHAR_WIDETAG:
+        case CHARACTER_WIDETAG:
             c = (obj>>8)&0xff;
             switch (c) {
                 case '\0':
@@ -275,7 +275,7 @@
 	    printf(", unknown type (0x%0x)", type);
 
     switch (widetag_of(obj)) {
-        case BASE_CHAR_WIDETAG:
+        case CHARACTER_WIDETAG:
             printf(": ");
             brief_otherimm(obj);
             break;
@@ -471,191 +471,193 @@
         }
 
         switch (type) {
-            case BIGNUM_WIDETAG:
-                ptr += count;
-                NEWLINE_OR_RETURN;
-                printf("0x");
-                while (count-- > 0)
-                    printf("%08lx", (unsigned long) *--ptr);
-                break;
-
-            case RATIO_WIDETAG:
-                print_slots(ratio_slots, count, ptr);
-                break;
-
-            case COMPLEX_WIDETAG:
-                print_slots(complex_slots, count, ptr);
-                break;
-
-            case SYMBOL_HEADER_WIDETAG:
-                print_slots(symbol_slots, count, ptr);
-                break;
-
-            case SINGLE_FLOAT_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("%g", ((struct single_float *)native_pointer(obj))->value);
-                break;
-
-            case DOUBLE_FLOAT_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("%g", ((struct double_float *)native_pointer(obj))->value);
-                break;
-
+	case BIGNUM_WIDETAG:
+	    ptr += count;
+	    NEWLINE_OR_RETURN;
+	    printf("0x");
+	    while (count-- > 0)
+		printf("%08lx", (unsigned long) *--ptr);
+	    break;
+	    
+	case RATIO_WIDETAG:
+	    print_slots(ratio_slots, count, ptr);
+	    break;
+	    
+	case COMPLEX_WIDETAG:
+	    print_slots(complex_slots, count, ptr);
+	    break;
+	    
+	case SYMBOL_HEADER_WIDETAG:
+	    print_slots(symbol_slots, count, ptr);
+	    break;
+	    
+	case SINGLE_FLOAT_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("%g", ((struct single_float *)native_pointer(obj))->value);
+	    break;
+	    
+	case DOUBLE_FLOAT_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("%g", ((struct double_float *)native_pointer(obj))->value);
+	    break;
+	    
 #ifdef LONG_FLOAT_WIDETAG
-            case LONG_FLOAT_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("%Lg", ((struct long_float *)native_pointer(obj))->value);
-                break;
+	case LONG_FLOAT_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("%Lg", ((struct long_float *)native_pointer(obj))->value);
+	    break;
 #endif
-
+	    
 #ifdef COMPLEX_SINGLE_FLOAT_WIDETAG
-            case COMPLEX_SINGLE_FLOAT_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("%g", ((struct complex_single_float *)native_pointer(obj))->real);
-                NEWLINE_OR_RETURN;
-                printf("%g", ((struct complex_single_float *)native_pointer(obj))->imag);
-                break;
+	case COMPLEX_SINGLE_FLOAT_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("%g", ((struct complex_single_float *)native_pointer(obj))->real);
+	    NEWLINE_OR_RETURN;
+	    printf("%g", ((struct complex_single_float *)native_pointer(obj))->imag);
+	    break;
 #endif
-
+	    
 #ifdef COMPLEX_DOUBLE_FLOAT_WIDETAG
-            case COMPLEX_DOUBLE_FLOAT_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("%g", ((struct complex_double_float *)native_pointer(obj))->real);
-                NEWLINE_OR_RETURN;
-                printf("%g", ((struct complex_double_float *)native_pointer(obj))->imag);
-                break;
+	case COMPLEX_DOUBLE_FLOAT_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("%g", ((struct complex_double_float *)native_pointer(obj))->real);
+	    NEWLINE_OR_RETURN;
+	    printf("%g", ((struct complex_double_float *)native_pointer(obj))->imag);
+	    break;
 #endif
-
+	    
 #ifdef COMPLEX_LONG_FLOAT_WIDETAG
-            case COMPLEX_LONG_FLOAT_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("%Lg", ((struct complex_long_float *)native_pointer(obj))->real);
-                NEWLINE_OR_RETURN;
-                printf("%Lg", ((struct complex_long_float *)native_pointer(obj))->imag);
-                break;
-#endif
-
-            case SIMPLE_BASE_STRING_WIDETAG:
-                NEWLINE_OR_RETURN;
-                cptr = (char *)(ptr+1);
-                putchar('"');
-                while (length-- > 0)
-                    putchar(*cptr++);
-                putchar('"');
-                break;
-
-            case SIMPLE_VECTOR_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("length = %ld", length);
-                ptr++;
-                index = 0;
-                while (length-- > 0) {
-                    sprintf(buffer, "%d: ", index++);
-                    print_obj(buffer, *ptr++);
-                }
-                break;
-
-            case INSTANCE_HEADER_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("length = %ld", (long) count);
-                index = 0;
-                while (count-- > 0) {
-                    sprintf(buffer, "%d: ", index++);
-                    print_obj(buffer, *ptr++);
-                }
-                break;
-
-            case SIMPLE_ARRAY_WIDETAG:
-            case SIMPLE_BIT_VECTOR_WIDETAG:
-            case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
-            case SIMPLE_ARRAY_UNSIGNED_BYTE_4_WIDETAG:
-            case SIMPLE_ARRAY_UNSIGNED_BYTE_8_WIDETAG:
-            case SIMPLE_ARRAY_UNSIGNED_BYTE_16_WIDETAG:
-            case SIMPLE_ARRAY_UNSIGNED_BYTE_32_WIDETAG:
+	case COMPLEX_LONG_FLOAT_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("%Lg", ((struct complex_long_float *)native_pointer(obj))->real);
+	    NEWLINE_OR_RETURN;
+	    printf("%Lg", ((struct complex_long_float *)native_pointer(obj))->imag);
+	    break;
+#endif
+	    
+	case SIMPLE_BASE_STRING_WIDETAG:
+	case SIMPLE_CHARACTER_STRING_WIDETAG: /* FIXME */
+	    NEWLINE_OR_RETURN;
+	    cptr = (char *)(ptr+1);
+	    putchar('"');
+	    while (length-- > 0)
+		putchar(*cptr++);
+	    putchar('"');
+	    break;
+	    
+	case SIMPLE_VECTOR_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("length = %ld", length);
+	    ptr++;
+	    index = 0;
+	    while (length-- > 0) {
+		sprintf(buffer, "%d: ", index++);
+		print_obj(buffer, *ptr++);
+	    }
+	    break;
+	    
+	case INSTANCE_HEADER_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("length = %ld", (long) count);
+	    index = 0;
+	    while (count-- > 0) {
+		sprintf(buffer, "%d: ", index++);
+		print_obj(buffer, *ptr++);
+	    }
+	    break;
+	    
+	case SIMPLE_ARRAY_WIDETAG:
+	case SIMPLE_BIT_VECTOR_WIDETAG:
+	case SIMPLE_ARRAY_UNSIGNED_BYTE_2_WIDETAG:
+	case SIMPLE_ARRAY_UNSIGNED_BYTE_4_WIDETAG:
+	case SIMPLE_ARRAY_UNSIGNED_BYTE_8_WIDETAG:
+	case SIMPLE_ARRAY_UNSIGNED_BYTE_16_WIDETAG:
+	case SIMPLE_ARRAY_UNSIGNED_BYTE_32_WIDETAG:
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG
-	    case SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG:
+	case SIMPLE_ARRAY_SIGNED_BYTE_8_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG
-	    case SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG:
+	case SIMPLE_ARRAY_SIGNED_BYTE_16_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG
-	    case SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG:
+	case SIMPLE_ARRAY_SIGNED_BYTE_30_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG
-	    case SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG:
+	case SIMPLE_ARRAY_SIGNED_BYTE_32_WIDETAG:
 #endif
-            case SIMPLE_ARRAY_SINGLE_FLOAT_WIDETAG:
-            case SIMPLE_ARRAY_DOUBLE_FLOAT_WIDETAG:
+	case SIMPLE_ARRAY_SINGLE_FLOAT_WIDETAG:
+	case SIMPLE_ARRAY_DOUBLE_FLOAT_WIDETAG:
 #ifdef SIMPLE_ARRAY_LONG_FLOAT_WIDETAG
-            case SIMPLE_ARRAY_LONG_FLOAT_WIDETAG:
+	case SIMPLE_ARRAY_LONG_FLOAT_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG
-	    case SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG:
+	case SIMPLE_ARRAY_COMPLEX_SINGLE_FLOAT_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG
-	    case SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG:
+	case SIMPLE_ARRAY_COMPLEX_DOUBLE_FLOAT_WIDETAG:
 #endif
 #ifdef SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG
-	    case SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG:
+	case SIMPLE_ARRAY_COMPLEX_LONG_FLOAT_WIDETAG:
 #endif
-            case COMPLEX_BASE_STRING_WIDETAG:
-            case COMPLEX_VECTOR_NIL_WIDETAG:
-            case COMPLEX_BIT_VECTOR_WIDETAG:
-            case COMPLEX_VECTOR_WIDETAG:
-            case COMPLEX_ARRAY_WIDETAG:
-                break;
-
-            case CODE_HEADER_WIDETAG:
-                print_slots(code_slots, count-1, ptr);
-                break;
-
-            case SIMPLE_FUN_HEADER_WIDETAG:
-                print_slots(fn_slots, 5, ptr);
-                break;
-
-            case RETURN_PC_HEADER_WIDETAG:
-                print_obj("code: ", obj - (count * 4));
-                break;
-
-            case CLOSURE_HEADER_WIDETAG:
-                print_slots(closure_slots, count, ptr);
-                break;
-
-            case FUNCALLABLE_INSTANCE_HEADER_WIDETAG:
-                print_slots(funcallable_instance_slots, count, ptr);
-                break;
-
-            case VALUE_CELL_HEADER_WIDETAG:
-		print_slots(value_cell_slots, 1, ptr);
-                break;
-
-            case SAP_WIDETAG:
-                NEWLINE_OR_RETURN;
+	case COMPLEX_BASE_STRING_WIDETAG:
+	case COMPLEX_CHARACTER_STRING_WIDETAG:
+	case COMPLEX_VECTOR_NIL_WIDETAG:
+	case COMPLEX_BIT_VECTOR_WIDETAG:
+	case COMPLEX_VECTOR_WIDETAG:
+	case COMPLEX_ARRAY_WIDETAG:
+	    break;
+
+	case CODE_HEADER_WIDETAG:
+	    print_slots(code_slots, count-1, ptr);
+	    break;
+
+	case SIMPLE_FUN_HEADER_WIDETAG:
+	    print_slots(fn_slots, 5, ptr);
+	    break;
+	    
+	case RETURN_PC_HEADER_WIDETAG:
+	    print_obj("code: ", obj - (count * 4));
+	    break;
+
+	case CLOSURE_HEADER_WIDETAG:
+	    print_slots(closure_slots, count, ptr);
+	    break;
+
+	case FUNCALLABLE_INSTANCE_HEADER_WIDETAG:
+	    print_slots(funcallable_instance_slots, count, ptr);
+	    break;
+
+	case VALUE_CELL_HEADER_WIDETAG:
+	    print_slots(value_cell_slots, 1, ptr);
+	    break;
+	    
+	case SAP_WIDETAG:
+	    NEWLINE_OR_RETURN;
 #ifndef alpha
-                printf("0x%08lx", (unsigned long) *ptr);
+	    printf("0x%08lx", (unsigned long) *ptr);
 #else
-                printf("0x%016lx", *(lispobj*)(ptr+1));
+	    printf("0x%016lx", *(lispobj*)(ptr+1));
 #endif
-                break;
-
-            case WEAK_POINTER_WIDETAG:
-		print_slots(weak_pointer_slots, 1, ptr);
-                break;
-
-            case BASE_CHAR_WIDETAG:
-            case UNBOUND_MARKER_WIDETAG:
-                NEWLINE_OR_RETURN;
-                printf("pointer to an immediate?");
-                break;
-
-	    case FDEFN_WIDETAG:
-		print_slots(fdefn_slots, count, ptr);
-		break;
-		
-            default:
-                NEWLINE_OR_RETURN;
-                printf("Unknown header object?");
-                break;
+	    break;
+	    
+	case WEAK_POINTER_WIDETAG:
+	    print_slots(weak_pointer_slots, 1, ptr);
+	    break;
+	    
+	case CHARACTER_WIDETAG:
+	case UNBOUND_MARKER_WIDETAG:
+	    NEWLINE_OR_RETURN;
+	    printf("pointer to an immediate?");
+	    break;
+	    
+	case FDEFN_WIDETAG:
+	    print_slots(fdefn_slots, count, ptr);
+	    break;
+	    
+	default:
+	    NEWLINE_OR_RETURN;
+	    printf("Unknown header object?");
+	    break;
         }
     }
 }
